Unit FTF1P_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure FTF1P(var ARE :Array of Extended; var AIM :Array of Extended;
                N :Integer; IN_ :Integer; K :Integer; var P :Extended);

implementation

procedure FTF1P(var ARE :Array of Extended; var AIM :Array of Extended;
                N :Integer; IN_ :Integer; K :Integer; var P :Extended);
var
I,II,J,JJ,N1,N2,M,MM :Integer;
R,T,SI,CO,S,C,A,B :Extended;
const
SYS001 :Real = 3.1415926535897932384626433832795;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13;
begin
N1 := N div 2;
MM := N1 div 2;
N2 := N1+K;
J := IN_;
JJ := J;
_1:
J := J+K;
if ( J-N1 ) < 0
 then goto _2
 else if ( J-N1 ) > 0
       then goto _7
       else goto _2;
_2:
II := JJ+N1;
R := ARE[J-1];
ARE[J-1] := ARE[II-1];
ARE[II-1] := R;
R := AIM[J-1];
AIM[J-1] := AIM[II-1];
AIM[II-1] := R;
J := J+K;
M := MM;
_3:
if ( JJ-M ) < 0
 then goto _5
 else if ( JJ-M ) > 0
       then goto _4
       else goto _5;
_4:
JJ := JJ-M;
M := M div 2;
goto _3;
_5:
JJ := JJ+M;
if ( JJ-J ) < 0
 then goto _1
 else if ( JJ-J ) > 0
       then goto _6
       else goto _1;
_6:
R := ARE[J-1];
ARE[J-1] := ARE[JJ-1];
ARE[JJ-1] := R;
R := AIM[J-1];
AIM[J-1] := AIM[JJ-1];
AIM[JJ-1] := R;
I := J+N2;
II := JJ+N2;
R := ARE[I-1];
ARE[I-1] := ARE[II-1];
ARE[II-1] := R;
R := AIM[I-1];
AIM[I-1] := AIM[II-1];
AIM[II-1] := R;
goto _1;
_7:
I := K;
T := SYS001;
if ( P ) < 0
 then goto _9
 else if ( P ) > 0
       then goto _8
       else goto _13;
_8:
T := -T;
_9:
P := -T;
_10:
SI := 0.e0;
CO := 1.e0;
S := Sin(T);
C := Cos(T);
T := 0.5e0*T;
II := I;
I := I+I;
M := IN_;
while ( M<=II ) do
 begin
  J := M;
  while ( J<=N ) do
   begin
    JJ := J+II;
    A := ARE[JJ-1];
    B := AIM[JJ-1];
    R := A*CO-B*SI;
    ARE[JJ-1] := ARE[J-1]-R;
    ARE[J-1] := ARE[J-1]+R;
    R := B*CO+A*SI;
    AIM[JJ-1] := AIM[J-1]-R;
_11:
    AIM[J-1] := AIM[J-1]+R;
    inc(J,I);
   end;
  R := C*CO-S*SI;
  SI := C*SI+S*CO;
_12:
  CO := R;
  inc(M,K);
 end;
if ( I-N ) < 0
 then goto _10
 else if ( I-N ) > 0
       then goto _13
       else goto _13;
_13:
end;

end.
